/* information for bitmaps were suplmented by the independent     */
/* jpeg group's libjpeg6.0 rdbmp.c as well microsoft's bitmap.doc */

#include "frontend.h"

#ifndef NO_BMP

#define red_color   0
#define green_color 1
#define blue_color  2

#define COMPRESSED_RGB  0
#define COMPRESSED_RLE8 1
#define COMPRESSED_RLE4 2

#define MICROSOFT 0
#define OS2 1

struct image_data {
	int  image_type; /* type mircosoft or os2 */
	int  image_size; /* image size in bytes */
	int  image_height; /* image height */
	int  image_width; /* image width */
	int  image_planes; 
	int  number_of_colors; /* number of color 0 means ma for mode */
	int  bit_count; /* color depth 1 to 24bits */
	int  components; /* components used ie color depth */
	int  colormap[3][256]; /* color table for 8 bit bmp's */
	int  colormap_switch;
	int  image_compression; /* compression type */
	FILE *bitmap;
};

struct image_data image;


void
error_exit_bmp(char *text) { /* deal with error messages */
	fprintf(stderr, "%s\n", text);
	display_shutdown();
}


/* read in the color map */
void
read_colormap(int *cmap_read_size, int *cmap_length) { /* works */

	int i;
	*cmap_length = (image.number_of_colors) ? image.number_of_colors : 1 << image.bit_count;
    for (i = 0; i < *cmap_length; i++) {
	   	image.colormap[blue_color][i]  = getc(image.bitmap);
		image.colormap[green_color][i] = getc(image.bitmap);
	   	image.colormap[red_color][i]   = getc(image.bitmap);
		if(image.image_type == MICROSOFT) { /* os2 images have no blanks */
	    	(void) getc(image.bitmap);
			*cmap_read_size -= 4;
		}
		else { *cmap_read_size -= 3; } /* os2 2.X formated colormap */
   	}
fprintf(dfd, "finnished reading in first colormap\n");
}


void
display_8bit_bmp(int *image_red, int *image_green, int *image_blue) { /* read in bitmap information */
	int c, c1, i, row, col, j = 0;

fprintf(dfd, "running 8bit\n");
	if(image.image_compression == COMPRESSED_RGB) { /* std uncompressed bitmaps */
fprintf(dfd, "running uncompressed\n");
       j = image.image_height * image.image_width;
       for (row = 0; row < image.image_height; row++) {  
          j = j - image.image_width;
          for (col = 0; col < image.image_width; col++) { 
              image_red[j++] = getc(image.bitmap);
          }
          j = j - image.image_width;
       }
	}
    
	/* if compressed then decompress the bmp */
	else {
fprintf(dfd, "running compressed\n");
		row = image.image_height;
		col = 0;
        j = (image.image_height * image.image_width) - image.image_width;
		while(row > 0) { 
			c = getc(image.bitmap);
			if(c == 0x00) { /* escape codes */
				c1 = getc(image.bitmap);
				switch (c1) {  
					case 0x00 : /* end of a row */
						row--;
                        j = j - (image.image_width * 2);
						col = 0;
						break;
 					case 0x01 : /* end of the bitmap */
						row = 0; /* end of bitmap then quit */
						break;
					case 0x02 : /* movemove in x then y order */
						c1 = getc(image.bitmap);
						col += c1;
						c1 = getc(image.bitmap);
						row -= c1;
						break;
					default :
						for(i = 0; i < c1; i++, col++) { image_red[j++] = getc(image.bitmap); }
						if(c1 & 1) { getc(image.bitmap); } /* if odd number make it even */
						break;
				}
			}
			else if (c == EOF) { fprintf(stderr, "error reading bmp\n"); } /* error message */
			else { /* ecoded mode */
				c1 = getc(image.bitmap);
				for(i = 0; i < c; i++, col++) {
                   image_red[j++] = c1;
				 }		
   			}
		} /* while */
	} /* else */
}


void
display_24bit_bmp(int *image_red, int *image_green, int *image_blue) { /* display hires bitmaps ie 24bit ones */

	int row, col, j = 0;
    
int c;
fprintf(dfd, "started display 24bit\n");
	/* read each set of 3 number standing for the color and use it for that pixel */
    j = image.image_height * image.image_width;
    for (row = 0; row < image.image_height; row++) {  
       j = j - image.image_width;
       for (col = 0; col < image.image_width; col++) { 
           image_blue[j]  = getc(image.bitmap);
           image_green[j] = getc(image.bitmap);
           image_red[j++] = getc(image.bitmap);
       }
       j = j - image.image_width;
	}
}  


int
read_bmp_file(char *image_name, int *height, int *width, int *components, int *cmap_switch, int **image_red,
        	  int **image_green, int **image_blue, int cmap[3][256], int *cmap_length) {

	int  i, bytes_off, header_size, cmap_offset, padding;
	int  bmp_header[54], array_size;

	#define BYTES_PER_COLOR 4
	#define UCH(x)	((int) (x))
	#define GET_2B(array,offset)  ((unsigned int) UCH(array[offset]) + \
			       (((unsigned int) UCH(array[offset+1])) << 8))
	#define GET_4B(array,offset)  ((int) UCH(array[offset]) + \
			       (((int) UCH(array[offset+1])) << 8) + \
			       (((int) UCH(array[offset+2])) << 16) + \
			       (((int) UCH(array[offset+3])) << 24))

	image.bitmap = fopen(image_name, "rb"); 

	for(i = 0; i < 54; i++) {
		bmp_header[i] = getc(image.bitmap);
	}

	/* get bmp data */
	bytes_off 		      		  = (int) GET_4B(bmp_header,10);
	header_size 		      	  = (int) GET_4B(bmp_header,14);
	image.image_width  = *width   = (int) GET_4B(bmp_header,18);
   	image.image_height = *height  = (int) GET_4B(bmp_header,22);
	image.image_planes	          = (int) GET_2B(bmp_header,26); 
  	image.bit_count		          = (int) GET_2B(bmp_header,28);
	image.image_compression	      = (int) GET_4B(bmp_header,30);
	image.image_size              = (int) GET_4B(bmp_header,34);
	image.number_of_colors        = (int) GET_4B(bmp_header,46);
	/* OFFSET TO 54 PLACES IN FILE */

    array_size   = (int)( (*width * *height) * 1.5);
    *image_red   = (int*)malloc(array_size * sizeof(int));
    *image_green = (int*)malloc(array_size * sizeof(int));
    *image_blue  = (int*)malloc(array_size * sizeof(int));
 
	/* check for format errors */
	if(image.image_compression == COMPRESSED_RLE4) { error_exit_bmp("4bit compressed format bitmap"); }
	if(header_size == 12) { error_exit_bmp("os2 1.X or windows 2.X bitmap"); }

	if(image.bit_count < 8) { error_exit_bmp("1 or 4bit bitmap type not supported"); }

	/* only big difference should be in the color map wether it is 3 or 4 bits long per color */
	if(header_size == 64) { image.image_type = OS2; } 
	else { image.image_type = MICROSOFT; }

	cmap_offset = header_size-40;
	for(i = 0; i < cmap_offset; i++) { (void) getc(image.bitmap); } /* make up the extra spaces */

	padding = bytes_off - (header_size -14); /* setup buffer of colormap */

	/* get colormaps and setup compoents for video mode */
	if(options.opt_forcemode == 0) { /* 8bit bitmaps should have 1 component ie 256 colors if not forced */
		if(image.bit_count == 8) { 
			image.components = *components = 1;
            read_colormap(&padding, cmap_length);
		}
		/* if quantizing or greyscaling components must be 1 */
		else if(options.opt_quantize == 1 || options.opt_greyscale == 1) { image.components = *components = 1; }
		else { image.components = *components = 3; } /* 24bit bitmaps should have 3 components unless forced */
	}
	else { /* if a mode is forced set the componets to that modetype */
		switch (options.opt_forcemode) {
			case 12: case 11: case 10: case 5:
				image.components = *components = 1;
				if(image.bit_count == 8) { read_colormap(&padding, cmap_length); }
		    	break;
            case 14: case 17: case 20: case 23:
				image.components = *components = 2;
				if(image.bit_count == 8) { read_colormap(&padding, cmap_length); }
		    	break;
		  	default :
				image.components = *components = 3;
				if(image.bit_count == 8) { read_colormap(&padding, cmap_length); }
		    	break;
		}
    }
    
	while (--padding > 0) { /* may not be needed */
    	(void) getc(image.bitmap);
  	}

	/* reset the bitmap and move to correct position */
	rewind(image.bitmap);
	for(i = 0; i < bytes_off; i++) { (void) getc(image.bitmap); }
fprintf(dfd, "set up bitmap\n");

	if (image.bit_count == 24) { display_24bit_bmp(*image_red, *image_green, *image_blue); }
	else { display_8bit_bmp(*image_red, *image_green, *image_blue); }

    *cmap_switch = 0;
fprintf(dfd, "components were %d\n", *components);
    if(*components == 1) {
        for(i = 0; i < *cmap_length; i++) {
fprintf(dfd, "%d %d %d\n", image.colormap[red_color][i],image.colormap[green_color][i],image.colormap[blue_color][i]);
            if(image.colormap[red_color][i] == 0 && image.colormap[green_color][i] == 0 &&
               image.colormap[blue_color][i] == 0) { 
fprintf(dfd, "%d has passed tests\n", i);
               *cmap_switch = i;
               break;
            }
        }
fprintf(dfd, "after checking innerloop we have found i to be %d\n", i);
        if(i >= *cmap_length) {
           if(i < 256) { 
              i++;
              *cmap_length = *cmap_length + 2;
              image.colormap[red_color][i]   = 0; 
              image.colormap[green_color][i] = 0;
              image.colormap[blue_color][i]  = 0;
              *cmap_switch = i;
           }
        }
    }
    
    memcpy(cmap, image.colormap, (768 * (sizeof(int))) );

fprintf(dfd, "i = %d\n", i);
fprintf(dfd, "cmap_switch = %d\n", *cmap_switch);
fprintf(dfd, "c_map[red_color]  [%d] = %d\n", *cmap_switch, cmap[red_color][*cmap_switch]);
fprintf(dfd, "c_map[green_color][%d] = %d\n", *cmap_switch, cmap[green_color][*cmap_switch]);
fprintf(dfd, "c_map[blue_color] [%d] = %d\n", *cmap_switch, cmap[blue_color][*cmap_switch]);
	fclose(image.bitmap);
    return 1;
}
#endif

