/* pcx info comes from Microsoft's pcx format documentation and a lot of guess work */

#include "frontend.h"

#ifndef NO_PCX

#define red_color   0
#define green_color 1
#define blue_color  2

int
encget(int *pbyt, int *pcnt, FILE *fid) {

   int i;
   
   *pcnt = 1; /* safety play */
   if(EOF == (i = getc(fid))) return(EOF);

   if(0xc0 == (0xc0 & i))   {
      *pcnt = 0x3f & i;
      if(EOF == (i=getc(fid))) return(EOF);
   }
   *pbyt = i;
   return(0);
}


int
read_pcx_file(char *image_name, int *height, int *width, int *components, int *cmap_switch, int **image_red,
        	   int **image_green, int **image_blue, int cmap[3][256], int *cmap_length) {

	#define UCH(x)	((int) (x))
	#define GET_2B(array,offset)  ((unsigned int) UCH(array[offset]) + \
			       (((unsigned int) UCH(array[offset+1])) << 8))

   FILE *pcx;
   int  i, j, lcmap[3][256];
   int  encodeing = OFF, array_size;
   int  block, counter, bytesperpixel;
   char pcx_image[128], c, c1, comp;
   long current_place;
   
   pcx = fopen(image_name, "r");

   for(i = 0; i < 128; i++) pcx_image[i] = getc(pcx);
   
fprintf(dfd, "%d\n", pcx_image[1]);
   if(pcx_image[2] == 1) encodeing = ON;
fprintf(dfd, "%d\n", pcx_image[2]);

   bytesperpixel = ( pcx_image[3] == 1 ?  pcx_image[65] : pcx_image[3] );
   
   *width  = GET_2B(pcx_image, 8)  - GET_2B(pcx_image, 4) + 1;
   *height = GET_2B(pcx_image, 10) - GET_2B(pcx_image, 6) + 1;
fprintf(dfd, "w = %d\n", *width);
fprintf(dfd, "h = %d\n", *height);
fprintf(dfd, "cmapinfo = %d\n", GET_2B(pcx_image, 68) );

   array_size   = (int)( (*width * *height) * 1.5);
   *image_red   = (int*)malloc(array_size * sizeof(int));
   *image_green = (int*)malloc(array_size * sizeof(int));
   *image_blue  = (int*)malloc(array_size * sizeof(int));

   switch(bytesperpixel) {
      case 4 :
         fprintf(dfd, "not supported since who want 16 color images\n");
         break;
      case 8 : /* 256 color pcx */
         /* colormap setup */
        current_place = ftell(pcx); /* save current position */
         fseek(pcx, -769L, SEEK_END); /* goto end -769 places */
         if(getc(pcx) == 12) {
            *cmap_length = 256;
            for(j = 0; j < 256;) {
               lcmap[red_color][j]     = getc(pcx);
               lcmap[blue_color][j]    = getc(pcx);
               lcmap[green_color][j++] = getc(pcx);
            }
         }  
         fseek(pcx, current_place, SEEK_SET); /* return to saved position */
         /* colormap setup */
         
         if(encodeing == OFF) for(i = 0; i < *width * *height; i++) (*image_red)[i] = getc(pcx);
         else {
            j = 0;
            while(EOF != encget(&block, &counter, pcx) ) {
               for(i = 0; i < counter; i++) (*image_red)[j++] = block;
            }
         }
         break;
      case 16 : /* 32K color pcx */
fprintf(dfd, "error 16bit image\n");
         for(i = 0; i < *width * *height;) {
            c  = getc(pcx);
            c1 = getc(pcx);
            block = (c << 8) + c1;
            (*image_red)[i]    = ((block << 11) >> 11) * 8;
            (*image_green)[i]  = ((block << 6)  >> 11) * 8;
            (*image_blue)[i++] = ((block << 1)  >> 11) * 8;
if(i < 50) fprintf(dfd, "%d %d %d\n", (*image_red)[i - 1], (*image_green)[i - 1], (*image_blue)[i - 1] );
         }
         break;
      case 24 : /* 16M color pcx */
         for(i = 0; i < *width * *height;) {
            (*image_red)[i]    = getc(pcx);
            (*image_green)[i]  = getc(pcx);
            (*image_blue)[i++] = getc(pcx);
         }
         break;
   }
fprintf(dfd, "\nwritten was %d\n", i);

   if(options.opt_forcemode == 0) {
       if(bytesperpixel <= 8) comp = 1;
       else if(bytesperpixel == 16) comp = 2;
       else comp = 3;
   }
   else {
		switch (options.opt_forcemode) {
			case  5 :
			case 10 :
		  	case 11 :
		  	case 12 :
                comp = 1;
				break;
            case 14 :
            case 17 :
            case 20 :
            case 23 :
                comp = 2;
				break;
		  	default :
				comp = 3;
				break;
		}
   }

   *cmap_switch = 0;
   for(i = 0; i < *cmap_length; i++) {
        if(lcmap[red_color][i] == 0 && lcmap[green_color][i] == 0 && lcmap[blue_color][i] == 0) { 
            *cmap_switch = i;
            break;
        }
   }

   if(i >= *cmap_length) {
       if(i < 256) { 
          i++;
          *cmap_length++;
          lcmap[red_color][i]   = 0; 
          lcmap[green_color][i] = 0;
          lcmap[blue_color][i]  = 0;
          *cmap_switch = i;
       }
   }
   
   memcpy(cmap, lcmap, (768 * (sizeof(int))) );
fprintf(dfd, "comp = %d\n", comp);

   *components = comp;

   fclose(pcx);

   return 1;
}

#endif


