/* format info, suplemented by jpeg group's libjpeg6.0 rdppm.c */

#include "frontend.h"

#ifndef NO_PPM

#define red_color   0
#define green_color 1
#define blue_color  2


int
read_ppm_file(char *image_name, int *height, int *width, int *components, int *cmap_switch, int **image_red,
        	   int **image_green, int **image_blue, int cmap[3][256], int *cmap_length) {

   FILE *ppm;
   int  i, j, counter, c, store[3], array_size;
   char line[64];
   
   ppm = fopen(image_name, "rb");
   (void) getc(ppm); /* skip P */
   counter = getc(ppm); /* get next charitor */
   
   do { c = getc(ppm); } while(c != '\n');
   if(getc(ppm) == '#') {
fprintf(dfd, "skipping comment\n");
      do { c = getc(ppm); } while(c != '\n');
   }
      
   fgets(line, 64, ppm);
   for(i = 0; i < 64; i++) if(line[i] < '0' || line[i] > '9') line[i] = ':';
fprintf(dfd, "line is %s\n", line);
   for(i = 0; line[i] < '0' || line[i] > '9'; i++);
   for(j = 0; line[i] != ':'; j++) store[j] = convert_to_int(line[i++]);
   *width = return_value(store, j);
fprintf(dfd, "width is %d\n", *width);

   for(; line[i] < '0' || line[i] > '9'; i++);
   for(j = 0; line[i] != ':'; j++) store[j] = convert_to_int(line[i++]);
   *height = return_value(store, j);
fprintf(dfd, "height is %d\n", *height);

   fgets(line, 64, ppm); /* skip max value line */

   array_size   = (int)( (*width * *height) * 1.5);
   *image_red   = (int*)malloc(array_size * sizeof(int));
   *image_green = (int*)malloc(array_size * sizeof(int));
   *image_blue  = (int*)malloc(array_size * sizeof(int));

   if(options.opt_forcemode == 0) {
      if(counter == 5) *components = 1;
      else *components = 3;
   }
   else {
		switch (options.opt_forcemode) {
			case 12:
			case 11:
		  	case 10:
		  	case 5:
                *components = 1;
				break;
            case 14: 
            case 17: 
            case 20: 
            case 23:
                *components = 2;
                break;
		  	default :
                *components = 3;
				break;
		}
   }

   switch(counter) {
      case '5' :
fprintf(dfd, "greyscale\n");
        for(i = 0; i < 256; i++) {
           cmap[red_color][i]   = i;
           cmap[green_color][i] = i;
           cmap[blue_color][i]  = i;
        }
        *cmap_length = 255;
        
        for(i = 0; i < *width * *height; i++) {
           (*image_red)[i]   = getc(ppm);
        }        
   		break;
      case '6' :
fprintf(dfd, "color rbg\n");
        for(i = 0; i < *width * *height; i++) {
           (*image_red)[i]   = getc(ppm);
           (*image_green)[i] = getc(ppm);
           (*image_blue)[i]  = getc(ppm);
        }
   		break;
      default :
fprintf(dfd, "type unknown\n");
   		break;
   }   
   
   *cmap_switch = 0;

return 1;
}

#endif
