/* scaling taken from gl's scale.c modifications were made to allow it to work with arrays of */
/* the type used by this program many thanks to Harm Hanemaayer for the orignal code          */

#include "frontend.h"

#ifndef NO_SCALE

int 
muldiv64(int m1, int m2, int d) {
    return (long) m1 *(long) m2 / (long) d;
}


void
scale_array(int old_width, int old_height, int *old_image, int *new_image, int new_width, int new_height, 
        	int xfactor, int yfactor) {

   int *dp2, *dp1, *dp2old;
   int row, scale_row, scale_col, col, scale_row_int, length;
   
   dp2 = new_image;
   dp1 = old_image;
   
   scale_row = 0;
   for (row = 0; row < new_height;) {
      scale_col = 0;
      dp2old = dp2;
      col = 0;
      while (col < new_width) {
         *(dp2 + col) = *(dp1 + (scale_col >> 16) );
         scale_col += xfactor;
         col++;
      }
      dp2 += new_width;
      row++;
      while (row < new_height) {
         scale_row_int = scale_row >> 16;
         scale_row += yfactor;
         if ((scale_row >> 16) != scale_row_int) break;
         length = dp2 - dp2old;
         memcpy(dp2, dp2old, length);
         dp2old = dp2;
         dp2 += length;
         row++;
      }
      dp1 = old_image + (scale_row >> 16) * old_width;
   }
fprintf(dfd, "finnished scaling\n");
}


void
scale(int components, int width_old, int height_old,  int width_new, int height_new, int *image_red, 
      int *image_green, int *image_blue) {

    int xfactor, yfactor, array_size, *new_image, i;
    
    array_size = (width_new * height_new) + height_new;
    new_image  = malloc(array_size * sizeof(int));

    xfactor    = muldiv64(width_old, 65536, width_new);
    yfactor    = muldiv64(height_old, 65536, height_new);
    
    switch(components) {
        case 1:
fprintf(dfd, "using low res scale\n");
           scale_array(width_old, height_old, image_red, new_image, width_new, height_new, xfactor, yfactor);
           for(i = 0; i < array_size; i++) image_red[i] = new_image[i];
           break;
        case 3:
fprintf(dfd, "using high res scale\n");
           scale_array(width_old, height_old, image_red,   new_image, width_new, height_new, xfactor, yfactor);
           for(i = 0; i < array_size; i++) image_red[i]   = new_image[i];
           scale_array(width_old, height_old, image_green, new_image, width_new, height_new, xfactor, yfactor);
           for(i = 0; i < array_size; i++) image_green[i] = new_image[i];
           scale_array(width_old, height_old, image_blue,  new_image, width_new, height_new, xfactor, yfactor);
           for(i = 0; i < array_size; i++) image_blue[i]  = new_image[i];
           break;
    }
}

#endif
