#include "frontend.h"

#ifndef NO_TIFF

#include <tiffio.h>

#define red_color   0
#define green_color 1
#define blue_color  2


int 
read_tiff_file(char *image_name, int *height, int *width, int *components, int *cmap_switch, int **image_red,
        	   int **image_green, int **image_blue, int cmap[3][256], int *cmap_length) {


   TIFF   *tiff;
   uint32 w, h;
   uint32 *tiff_image;
   int    array_size, i, row, col;
   
   tiff = TIFFOpen(image_name, "r");
   
   TIFFGetField(tiff, TIFFTAG_IMAGEWIDTH, &w);
   TIFFGetField(tiff, TIFFTAG_IMAGELENGTH, &h);

   tiff_image = (uint32*) _TIFFmalloc( (w * h) * sizeof(uint32) );

   array_size   = (int)( (w * h) * 1.5);
   *image_red   = (int*)malloc(array_size * sizeof(int));
   *image_green = (int*)malloc(array_size * sizeof(int));
   *image_blue  = (int*)malloc(array_size * sizeof(int));

   TIFFReadRGBAImage(tiff, w, h, tiff_image, 0);

   for(i = 0, row = h; row > 0; row--) {
      for(col = 0; col < w; col++) { 
         (*image_red)[i]    = TIFFGetR(tiff_image[(row * w) + col]);
         (*image_green)[i]  = TIFFGetG(tiff_image[(row * w) + col]);
         (*image_blue)[i++] = TIFFGetB(tiff_image[(row * w) + col]);
         TIFFGetA(tiff_image[(row * w) + col]);
      }
   }

   *cmap_switch = 0;
   *width  		= w;
   *height      = h;
   *components  = 3; /* note that return values are in the form RGB */

fprintf(dfd, "width  is %d\n", *width);
fprintf(dfd, "height is %d\n", *height);
fprintf(dfd, "comp   is %d\n", *components);

   _TIFFfree(tiff_image);
   TIFFClose(tiff);
   return 1;
}   

#endif
