#include "frontend.h"

#ifndef NO_TEXT

#include "keydef.h"

#define MAXLINELENGTH 250
#define NON_EOF 5

int
write_screen(WINDOW *write_window, FILE *read_file) {

    int  i, error_check;
    char file_line[MAXLINELENGTH]; 

    i = 0;
    do {
	fgets(file_line, MAXLINELENGTH, read_file);

	error_check = getc(read_file);
	if(error_check != EOF) {
		ungetc(error_check, read_file);
		error_check = NON_EOF;
	}

  	if(strlen(file_line) > COLS - 4) file_line[COLS - 5] = '\0'; 
	mvwprintw(write_window, (i + 1), 1, "%s", file_line);
	i++;
    } while(i < LINES - 3 && error_check != EOF);
    return error_check;
}


int 
read_text(char *file_name) {

	WINDOW	*textwin;
	FILE	*text_file;
    	int 	error_check, j, respo;
	long	prev_pos[5000];

	text_file = fopen(file_name, "r");
   	textwin = newwin( (LINES-2), (COLS-2), 1, 1);
	keypad(textwin, TRUE);
	prev_pos[0] = 0L;
	j = 0;
	
	do {
		fseek(text_file, prev_pos[j], SEEK_SET);
        	werase(textwin);
	
   		error_check =  write_screen(textwin, text_file);

    		wborder(textwin, ACS_VLINE, ACS_VLINE, ACS_HLINE, ACS_HLINE,
        	             ACS_ULCORNER, ACS_URCORNER, ACS_LLCORNER, ACS_LRCORNER); 
		wrefresh(textwin);

   		raw();
   		noecho();
  		respo = wgetch(textwin);
		echo();
		noraw();
        
		switch(respo) {
   	        case KEY_PPAGE :
		case KEY_UP :
    		case KEY_K  :
		case KEY_k  : /* up */
			if(j > 0) j--;
			if(error_check != NON_EOF) error_check = NON_EOF;
			break;
       	    	case KEY_NPAGE :
 	    	case KEY_DOWN  :
            	case KEY_SPACE :
		case KEY_J :
    		case KEY_j :  /* down */
   	    		if(error_check == NON_EOF) prev_pos[++j] = ftell(text_file);
			break;
		case KEY_ENTER : /* view current */
		case KEY_N :
	    	case KEY_n :
                	fclose(text_file);
   			delwin(textwin);
           	    	redrawscreen();
			return RETURN_KEY;
			break;
		case KEY_ESC :
		default    :
                	fclose(text_file);
   			delwin(textwin);
           	    	redrawscreen();
			return ESC_KEY;
			break;
	    	case KEY_CTRL_X : /* view current */
   	 		delwin(textwin);
			runexit(DIS_ON); 
			break;
	    	case KEY_BACK : /* view prevous */
		case KEY_P :
    		case KEY_p :
                	fclose(text_file);
     			delwin(textwin);
               		redrawscreen();
			return BACK_KEY;
			break;
       	    	case KEY_R :
           	case KEY_r : /* refresh the screen  */
            		redrawscreen();
   	            	break;
        }
    } while(1);
return ERROR_KEY;
}

#endif

