#include "frontend.h"
#include "keydef.h"
#include <sys/stat.h>
#include <pwd.h>
#include <sys/types.h>
#include <vga.h>
#include <vgagl.h>


void
killmodelist(bmode *tokill) {
	
	if(tokill != NULL) {
		while(tokill->nextentry != NULL) {
			tokill = tokill->nextentry;
			free(tokill->preventry);
		}
	free(tokill);
	}
}


void	
runexit(int d) {

	WINDOW	*exitwin;
	int 	i;

	killmodelist(best_mode_256head);
	killmodelist(best_mode_32Khead);
	killmodelist(best_mode_16Mhead);

	/* free up the screen windows */
	for(i = 0; i < (LINES-5); i++) {
		delwin(window[i] );
		delwin(window[i+(LINES-4)] );
		delwin(window[i+((LINES-4)*2)] );
	}

	if(d == DIS_ON) { 
    	exitwin = newwin(3, 25, (LINES/2-1), (COLS-COLS/2-13) );
	    wborder(exitwin, ACS_VLINE, ACS_VLINE, ACS_HLINE, ACS_HLINE,
    	                 ACS_ULCORNER, ACS_URCORNER, ACS_LLCORNER, ACS_LRCORNER); 
		wattron(exitwin, A_BLINK);
    	mvwprintw(exitwin, 1, 2, "Press any key to exit");
	    wrefresh(exitwin);
		raw();
		noecho();
		wgetch(exitwin);
		echo();
		noraw();
	}
    clear();
    refresh();
    endwin();
    exit(0);
}


void
options_menu() {
   WINDOW *optwin;
   int response, ex = 0;
   
   optwin = newwin(11, 36, (LINES/2-5), (COLS-COLS/2-18) );
   wborder(optwin, ACS_VLINE, ACS_VLINE, ACS_HLINE, ACS_HLINE,
    	                 ACS_ULCORNER, ACS_URCORNER, ACS_LLCORNER, ACS_LRCORNER); 
   do {
	  mvwprintw(optwin, 1, 6, "graphics viewer options");
      mvwprintw(optwin, 2, 6, "------------------------");
      if(options.opt_greyscale == 0) mvwprintw(optwin, 4, 2, "Greyscale (G) : OFF");
      else mvwprintw(optwin, 4, 2, "Greyscale (G) : ON ");
      if(options.opt_quantize == 0) mvwprintw(optwin, 5, 2, "Quantize (Q) : OFF");
      else mvwprintw(optwin, 5, 2, "Quantize (Q) : ON ");
      if(options.opt_forcescale == 0) mvwprintw(optwin, 6, 2, "Scaling (S) : OFF");
      else mvwprintw(optwin, 6, 2, "Scaling (S) : ON ");      
      if(dirwininfo.marked == OFF) mvwprintw(optwin, 7, 2, "Marked files (M) : OFF");
      else mvwprintw(optwin, 7, 2, "Marked files (M) : ON ");
	  mvwprintw(optwin, 9, 5, "Press any other key to quit");
	  wrefresh(optwin);

	  raw();
	  noecho();
  	  response = wgetch(optwin);
      echo();
	  noraw();
      
      switch (response) {
         case KEY_Q :
         case KEY_q :
            if(options.opt_quantize == ON) options.opt_quantize = OFF;
            else options.opt_quantize = ON;
            break;
         case KEY_G :
         case KEY_g :
            if(options.opt_greyscale == ON) options.opt_greyscale = OFF;
            else options.opt_greyscale = ON;
            break;
         case KEY_S :
         case KEY_s :
            if(options.opt_forcescale == ON) options.opt_forcescale = OFF;
            else options.opt_forcescale = ON;
            break;
         case KEY_M :
         case KEY_m :
            if(dirwininfo.marked == ON) dirwininfo.marked = OFF;
            else dirwininfo.marked = ON;
            break;
   	     case KEY_CTRL_X : /* quit the program */	
     		delwin(optwin);
			runexit(DIS_ON); 
			break;
         default :
            ex = 1;
            break;
      }
   } while (ex == 0);
   werase(optwin);
   redrawscreen();
}


int
runvideo(int forcemode) {

    struct modes {
       char *mode_name;
       int  mode_number;
    };

	WINDOW *videowin[12], *videowin_gobal;
    struct modes aval_modes[10];
	struct modes info_for_mode[] = {
		{"Mode 5  :  320x200x256",  5},
		{"Mode 10 :  640x480x256", 10},
		{"Mode 11 :  800x600x256", 11},
		{"Mode 12 : 1024x768x256", 12},
		{"Mode 17 :  640x480x32K", 17},
		{"Mode 20 :  800x600x32K", 20},
		{"Mode 23 : 1024x768x32K", 23},
		{"Mode 33 :  320x200x16M", 33},
		{"Mode 34 :  640x480x16M", 34},
		{"Mode 35 :  800x600x16M", 35},
		{"Mode 0  :force no mode",  0}, 
		{" ", 100},
	};
    int get_mode, i = 0, curwin = -1, j = 0, k;
	
	/* create video window */

    j = 0;
	videowin_gobal = newwin(15, 24, (LINES/2-7), (COLS-COLS/2-12) );
	keypad(videowin_gobal, TRUE);

	for(i = 1; i < GLASTMODE; i++) { 
       if( vga_hasmode(i) ) {
          switch(i) {
             case 5  : 
             case 10 :
             case 11 :
             case 12 :
             case 17 :
             case 20 :
             case 23 :
             case 33 :
             case 34 :
             case 35 :
            	 k = 0;
            	 while(k < 11) {
                    if(info_for_mode[k].mode_number == i) {
                       aval_modes[j].mode_name   = info_for_mode[k].mode_name;
                       aval_modes[j].mode_number = info_for_mode[k].mode_number;
                    	videowin[j] = derwin(videowin_gobal, 1, 22, j + 1, 1);
                        j++;
                    }
                    k++;
                 }
                 break;
             default :
                 break;
          }
       }
       /* force add -1 to list */
   	   aval_modes[j].mode_number = info_for_mode[10].mode_number;
       aval_modes[j].mode_name   = info_for_mode[10].mode_name;
       videowin[j] = derwin(videowin_gobal, 1, 22, j + 1, 1);
    }

    werase(videowin_gobal); 
    wborder(videowin_gobal, ACS_VLINE, ACS_VLINE, ACS_HLINE, ACS_HLINE,
                        	ACS_ULCORNER, ACS_URCORNER, ACS_LLCORNER, ACS_LRCORNER); 

    curwin = j;
    for(i = 0 ; i < j; i++) { 
          if(aval_modes[i].mode_number == forcemode) curwin  = i;
    }
        
	wattron(videowin[curwin], A_BOLD);

	for(i = 0; i <= j; i++) {
		wprintw(videowin[i], "%s", aval_modes[i].mode_name);
	}

	wattroff(videowin[curwin], A_BOLD);
	mvwprintw(videowin_gobal, 12, 4, "use JK and the ");
	mvwprintw(videowin_gobal, 13, 2, "arrow keys to choice");

	/* update all the windows */
	wrefresh(videowin_gobal);

	do {
	  raw();
	  noecho();
	  get_mode = wgetch(videowin_gobal);
	  echo();
	  noraw();
	
	  switch(get_mode) {
		case KEY_J :	/* down */
		case KEY_j :	
		case KEY_DOWN :	
			werase(videowin[curwin]);
			wprintw(videowin[curwin], "%s", aval_modes[curwin]);
		    wrefresh(videowin[curwin]);
			if(curwin < j) {
				curwin++;
				wattron(videowin[curwin], A_BOLD);
			}
			else {
				curwin = 0;
				wattron(videowin[curwin], A_BOLD);
			}
			wprintw(videowin[curwin], "%s", aval_modes[curwin]);
			wattroff(videowin[curwin], A_BOLD);
			wrefresh(videowin[curwin]);
			break;
		case KEY_K :	
		case KEY_k :	
		case KEY_UP :	
			werase(videowin[curwin]);
			wprintw(videowin[curwin], "%s", aval_modes[curwin]);
		    wrefresh(videowin[curwin]);
			if(curwin > 0) {
				curwin--;
				wattron(videowin[curwin], A_BOLD);
			}
			else {
				curwin = j;
				wattron(videowin[curwin], A_BOLD);
			}
			wprintw(videowin[curwin], "%s", aval_modes[curwin]);
			wattroff(videowin[curwin], A_BOLD);
			wrefresh(videowin[curwin]);
			break;
		case KEY_ENTER :	
            forcemode = aval_modes[curwin].mode_number;
			break;
		case KEY_CTRL_X :
				for(i = 0; i < j; i++) {
					delwin(videowin[i]);
				}
				delwin(videowin_gobal);
				runexit(DIS_ON);
				break; 
	  }
	} while (get_mode != KEY_ENTER); 

	/* clean up the screen delete windows and the such */
	for(i = 0; i < j; i++) {
		delwin(videowin[i]);
	}
	delwin(videowin_gobal);
	redrawscreen();
	return forcemode;
}


void
runhelp() {

	WINDOW  *helpwin;

	/* create window options */
	helpwin = newwin(20, 36, (LINES/2-8), (COLS-COLS/2-18) );
	werase(helpwin);
	mvwprintw(helpwin, 1, 13, "HelpMenu\n");
	mvwprintw(helpwin, 2, 13, "--------\n");
	wprintw(helpwin, "  H Scroll one colmn to the left\n");
	wprintw(helpwin, "  L Scroll one colmn to the right\n");
	wprintw(helpwin, "  J Scroll up one line\n");
	wprintw(helpwin, "  K Scroll down one line\n");
	wprintw(helpwin, "  D Enter a new directory\n");
	wprintw(helpwin, "  I change file stats\n");
	wprintw(helpwin, "  R Refresh the screen\n");
	wprintw(helpwin, "  U Go to prevous directory\n");
    wprintw(helpwin, "  O Options menu\n");
	wprintw(helpwin, "  INST   copy current   file\n");
	wprintw(helpwin, "  DEL    delete current file\n");
	wprintw(helpwin, "  ENTER  current view   file\n");
	wprintw(helpwin, "  SPACE  mark current   file\n");
	wprintw(helpwin, "  CTRL_X to exit program\n"); 
	wprintw(helpwin, "\n"); 
	mvwprintw(helpwin, 18, 5, "Press enter to continue\n");
	wborder(helpwin, ACS_VLINE, ACS_VLINE, ACS_HLINE, ACS_HLINE,
    	             ACS_ULCORNER, ACS_URCORNER, ACS_LLCORNER, ACS_LRCORNER); 
	wrefresh(helpwin);
	raw();
	noecho();
	wgetch(helpwin);
	echo();
	noraw();
	delwin(helpwin);
    writeoutlist(dirwininfo.writeoffset);
	dorefreshwindows();
}


void
enternewdir(char *path_to_change) {	

  WINDOW		*movetowin;
  int			doesnotexist = 0, j, i;
  char			dirpathtemp[128], pathtempext[128], username[16];
  struct passwd *userinfo;


	/* deal with want to change directories */
	if(strncmp(path_to_change, "--", 3) == 0) {
		movetowin = newwin(4, 60, (LINES/2-2), (COLS-COLS/2-30) ); 
		strcpy(dirwininfo.prevdir, dirwininfo.dirpath); /* back up current directory */
		do {
   	      werase(movetowin); 
       	  wborder(movetowin, ACS_VLINE, ACS_VLINE, ACS_HLINE, ACS_HLINE,
           	                 ACS_ULCORNER, ACS_URCORNER, ACS_LLCORNER,
		      				 ACS_LRCORNER); 
	   	   mvwprintw(movetowin, 1, 12, "Enter the directory to move to :");
		   wrefresh(movetowin);
	   	   mvwgetstr(movetowin, 2, 1, dirpathtemp);
		   if(strncmp(dirpathtemp, "/", 1) == 0) {
				strcpy(dirwininfo.dirpath, dirpathtemp);
   			}
			else if(strncmp(dirpathtemp, "~", 1) == 0) {
				for(j = 0; dirpathtemp[j + 1] != '/' && dirpathtemp[j + 1] != '\0'; j++) username[j] = dirpathtemp[j + 1];
				if(dirpathtemp[j + 1] == '/') {
					for(j = ++j, i = 0; dirpathtemp[j] != '\0'; j++, i++) pathtempext[i] = dirpathtemp[j];
					strcpy(dirpathtemp, pathtempext);
				}
				else { strcpy(dirpathtemp, "\0"); }
				do { userinfo = getpwent();	} while(strcmp(userinfo->pw_name, username) != 0);
				strcpy(dirwininfo.dirpath, userinfo->pw_dir);
				if(strncmp(dirpathtemp, "\0", 1) != 0) {
					strcat(dirwininfo.dirpath, dirpathtemp);
				}
			}
	   		else {
				getcwd(dirwininfo.dirpath, 127); 
				strcat(dirwininfo.dirpath, "/");
				strcat(dirwininfo.dirpath, dirpathtemp);
   			}
	   		doesnotexist = chdir(dirwininfo.dirpath);
		} while (doesnotexist == -1);
   	delwin(movetowin);
	} /* make sure the path exist while it does not loop */

	else { 
		/* given by enter ie up or down one directory */
		chdir(path_to_change);
		strcpy(dirwininfo.prevdir, dirwininfo.dirpath); /* backup current directory */
		getcwd(dirwininfo.dirpath, 127);
	}

	dirwininfo.writeoffset = 0;
	doesnotexist = strlen(dirwininfo.dirpath);

    /* read directories */
    dirwininfo.totalentries = readdirectories();
	linked_directory = linked_directory_head;
	redrawscreen();
}
