#include "frontend.h"

#ifndef NO_XBITMAP

#include <vga.h>
#include <vgagl.h>

#define red_color   0
#define green_color 1
#define blue_color  2

void
convert_to_bin(char c, int *ret0, int *ret1, int *ret2, int *ret3) {

	switch(c) {
		case '0' : 
			*ret0 = 0; *ret1 = 0; *ret2 = 0; *ret3 = 0; 
			break;
		case '1' :
			*ret0 = 0; *ret1 = 0; *ret2 = 0; *ret3 = 1;
			break;
		case '2' :
			*ret0 = 0; *ret1 = 0; *ret2 = 1; *ret3 = 0;
			break;
		case '3' :
			*ret0 = 0; *ret1 = 0; *ret2 = 1; *ret3 = 1;
			break;
		case '4' : 
			*ret0 = 0; *ret1 = 1; *ret2 = 0; *ret0 = 0;
			break;
		case '5' :
			*ret0 = 0; *ret1 = 1; *ret2 = 0; *ret3 = 1; 
			break;
		case '6' :
			*ret0 = 0; *ret1 = 1; *ret2 = 1; *ret3 = 0;
			break;
		case '7' :
			*ret0 = 0; *ret1 = 1; *ret2 = 1; *ret3 = 1;
			break;
		case '8':
			*ret0 = 1; *ret1 = 0; *ret2 = 0; *ret3 = 0;
			break;
		case '9' :
			*ret0 = 1; *ret1 = 0; *ret2 = 0; *ret3 = 1;
			break;
		case 'A' : case 'a' :
			*ret0 = 1; *ret1 = 0; *ret2 = 1; *ret3 = 0;
			break;
		case 'B' : case 'b' :
			*ret0 = 1; *ret1 = 0; *ret2 = 1; *ret3 = 1;
			break;
		case 'C' : case 'c' : 
			*ret0 = 1; *ret1 = 1; *ret2 = 0; *ret3 = 0;
			break;
		case 'D' : case 'd' :
			*ret0 = 1; *ret1 = 1; *ret2 = 0; *ret3 = 1;
			break;
		case 'E' : case 'e' :
			*ret0 = 1; *ret1 = 1; *ret2 = 1; *ret3 = 0;
			break;
		case 'F' : case 'f' :
			*ret0 = 1; *ret1 = 1; *ret2 = 1; *ret3 = 1;
			break;
	}
    
fprintf(dfd, " '%d%d%d%d' ", *ret0, *ret1, *ret2, *ret3);
}	


void
display_xbitmap(int width, int height, FILE *xbitmap, int *image_red) {

	int pic1[4], pic2[4];
	int j = 0;
	int finished = 0;
	char c;

fprintf(dfd, "started display\n");
	while(!finished) {
		c = getc(xbitmap);
		for (; c != 'x' && c != '}' && c != EOF; c = getc(xbitmap)) { fprintf(dfd, "c is %c\n", c); }
fprintf(dfd, "c is %c\n", c);
		if(c !='}' && c != EOF) {
fprintf(dfd, "continuing loop\n");
			c = getc(xbitmap);
fprintf(dfd, "%c", c);
			convert_to_bin( c, &image_red[j+7], &image_red[j+6], &image_red[j+5], &image_red[j+4]);
			c = getc(xbitmap);
fprintf(dfd, "%c", c);
			convert_to_bin( c, &image_red[j+3], &image_red[j+2], &image_red[j+1], &image_red[j]);
			j += 8;
		} 
        else { finished = 1; }
fprintf(dfd, "\nfinnished a loop\n");
	}
fprintf(dfd, "finnished whole\n");
}


int
read_xbitmap_file(char *image_name, int *height, int *width, int *components, int **image_red, int **image_green, 
                  int **image_blue, int cmap[3][256], int *cmap_length, int *cmap_switch) {
	
	FILE *xbitmap;
	char *line, *name;
	int w, h, array_size;
	int comp, i;

	xbitmap = fopen(image_name, "r");

	fgets(line, 256, xbitmap);
	for(i = 0; line[i] != ' '; i++);
	i++;
	for(; line[i] != ' '; i++);
	i++;
	w  =  convert_to_int(line[i++]) * 10;
	w += convert_to_int(line[i]);
fprintf(dfd, "width is %d\n", w);

	fgets(line, 256, xbitmap);
	for(i = 0; line[i] != ' '; i++);
	i++;
	for(; line[i] != ' '; i++);
	i++;
	h  = convert_to_int(line[i++]) * 10;
	h += convert_to_int(line[i]);
fprintf(dfd, "height is %d\n", h);

	do {
		fgets(line, 256, xbitmap);
	} while(strncmp(line, "static", 6) != 0);

	if(options.opt_forcemode == 0) { comp = 1; }
	else {
		switch (options.opt_forcemode) {
			case 12:
			case 11:
		  	case 10:
		  	case 5:
				comp = 1;
				break;
            case 14: 
            case 17: 
            case 20: 
            case 23:
                comp = 2;
                break;
		  	default :
				comp = 3;
				break;
		}
	}
fprintf(dfd, "components are %d\n", comp);

    array_size   = (int)( (w * h) * 1.5);
    *image_red   = (int*)malloc(array_size * sizeof(int));
    *image_green = (int*)malloc(array_size * sizeof(int));
    *image_blue  = (int*)malloc(array_size * sizeof(int));
fprintf(dfd, "array_size is %d\n", array_size);

	display_xbitmap(w, h, xbitmap, *image_red);
    
	if(comp == 1) { /* display in 8bit mode */
		cmap[red_color][0] = cmap[green_color][0] = cmap[blue_color][0] = 60;
		cmap[red_color][1] = cmap[green_color][1] = cmap[blue_color][1] = 255;
		cmap[red_color][2] = cmap[green_color][2] = cmap[blue_color][2] = 0;
        *cmap_length = 3;
        *cmap_switch = 3;
    }
    else {
        for(i = 0; i < w * h; i++) {
           if(image_red[i] == 0) { *image_red[i] = *image_green[i] = *image_blue[i] = 60; }
           else { *image_red[i] = *image_green[i] = *image_blue[i] = 255; }
        }
    }

    *width      = w;
    *height     = h;
    *components = comp;

	fclose(xbitmap);
	return 1;
}

#endif
